{**********************************************************************
                PilotLogic Software House.

 Package pl_RESTDataware
 This file is part of CodeTyphon Studio (https://www.pilotlogic.com/)
***********************************************************************}

unit allrestdwreg;

interface

uses
    StdCtrls, ComCtrls, Forms, ExtCtrls, DBCtrls, DBGrids, Dialogs, Controls, Variants, TypInfo,
    LResources, LazFileUtils, SysUtils, FormEditingIntf, PropEdits, lazideintf, ProjectIntf, ComponentEditors, Classes,
    fpWeb,
    uDWResponseTranslator,
    uRESTDWBase, uRESTDWProcessThread,
    uRESTDWPoolerDB,
    uDWDatamodule, uDWSqlEditor,
    uDWUpdSqlEditor, uDWFieldSourceEditor, uDWMassiveBuffer,
    uRESTDWServerEvents, uDWDataset, uRESTDWServerContext,
    uDWJSONViewer, uDWRequestDBG, dmdwcgiserver,
    uRESTDWBufferDb,
    uRestDWLazDriver, uRESTDWDriverZEOS, uRESTDWDriverRDW;


Const
 varUString  = Succ(Succ(varString)); { Variant type code }


Var
 EnabledAllTableDefs : Boolean = False;
 LoadAndStoreToForm  : Boolean = False;


Type
 TAddFields = Procedure (All: Boolean) of Object;

Type
 TDWFieldsList = Class(TStringProperty)
 Public
  Function  GetAttributes  : TPropertyAttributes; Override;
  Procedure GetValues(Proc : TGetStrProc);        Override;
  Procedure Edit;                                 Override;
End;

Type
 TPoolersList = Class(TStringProperty)
 Public
  Function  GetAttributes  : TPropertyAttributes; Override;
  Procedure GetValues(Proc : TGetStrProc);        Override;
  Procedure Edit;                                 Override;
End;

Type
 TTableList = Class(TStringProperty)
 Public
  Function  GetAttributes  : TPropertyAttributes; Override;
  Procedure GetValues(Proc : TGetStrProc);        Override;
  Procedure Edit;                                 Override;
End;

Type
 TPoolersListCDF = Class(TStringProperty)
 Public
  Function  GetAttributes  : TPropertyAttributes; Override;
  Procedure GetValues(Proc : TGetStrProc);        Override;
  Procedure Edit;                                 Override;
End;

Type
 TServerEventsList = Class(TStringProperty)
 Public
  Function  GetAttributes  : TPropertyAttributes; Override;
  Procedure GetValues(Proc : TGetStrProc);        Override;
  Procedure Edit;                                 Override;
End;

Type
 TServerEventsListCV = Class(TStringProperty)
 Public
  Function  GetAttributes  : TPropertyAttributes; Override;
  Procedure GetValues(Proc : TGetStrProc);        Override;
  Procedure Edit;                                 Override;
End;

type
 TDWServerEventsEditor = Class(TComponentEditor)
  Function  GetVerbCount       : Integer;  Override;
  Function  GetVerb     (Index : Integer): String; Override;
  Procedure ExecuteVerb(Index  : Integer); Override;
End;

Type
 TDWClientEventsEditor = Class(TComponentEditor)
  Function  GetVerbCount      : Integer;  Override;
  Function  GetVerb    (Index : Integer): String; Override;
  Procedure ExecuteVerb(Index : Integer); Override;
End;

Type
 TDWServerContextEditor = Class(TComponentEditor)
Public
 Function  GetVerbCount      : Integer;  Override;
 Function  GetVerb    (Index : Integer): String; Override;
 Procedure ExecuteVerb(Index : Integer); Override;
End;

Type
 TDWContextRulesEditor = Class(TComponentEditor)
Public
 Function  GetVerbCount      : Integer;  Override;
 Function  GetVerb    (Index : Integer): String; Override;
 Procedure ExecuteVerb(Index : Integer); Override;
End;


Type
 TRESTDWCGIApplicationDescriptor = Class(TProjectDescriptor)
 Public
  Constructor Create; Override;
  Function    GetLocalizedName          : String; Override;
  Function    GetLocalizedDescription   : String; Override;
  Function    InitProject     (AProject : TTyphonProject) : TModalResult; Override;
  Function    CreateStartFiles(AProject : TTyphonProject) : TModalResult; Override;
 End;
 TRESTDWCGIDatamodule = Class(TFileDescPascalUnitWithResource)
 Public
  Constructor Create; Override;
  Function    GetInterfaceUsesSection : String; Override;
  Function    GetInterfaceSource(const Filename, SourceName,
                                 ResourceName : String) : String; Override;
  Function    GetLocalizedName        : String; Override;
  Function    GetLocalizedDescription : String; Override;
  Function    GetImplementationSource(Const Filename,
                                      SourceName,
                                      ResourceName : String) : String;Override;
 End;
 TRESTDWDatamodule    = Class(TFileDescPascalUnitWithResource)
 Public
  Constructor Create;Override;
  Function    GetInterfaceUsesSection : String; Override;
  Function    GetInterfaceSource(const Filename, SourceName,
                                 ResourceName : String) : String; Override;
  Function    GetLocalizedName        : String; Override;
  Function    GetLocalizedDescription : String; Override;
  Function    GetImplementationSource(Const Filename,
                                      SourceName,
                                      ResourceName : String) : String;Override;
 End;

Procedure Register;

Resourcestring
  rsRESTDWCGIApplicati      = 'REST Dataware - CGI Application';
  rsRESTDWCGIApplicatiDesc  = 'REST Dataware - CGI Application%sA CGI (Common Gateway Interface) ' +
                              'program in Free Pascal using webmodules.';
  rsRESTDWStandaloneApp     = 'REST Dataware - Standalone Application';
  rsRESTDWStandaloneAppDesc = 'REST Dataware - Standalone Application%sA Standalone' +
                              'program in Free Pascal to use RDW HttpServer like REST Server.';
  rsRESTDWCGIDatamodule     = 'REST Dataware - CGI Datamodule';
  rsRESTDWCGIDatamoduleADa  = 'REST Dataware - CGI Datamodule%sA Datamodule for WEB (HTTP) Applications.';
  rsRESTDWDatamodule        = 'REST Dataware - Datamodule';
  rsRESTDWDatamoduleADa     = 'REST Dataware - Datamodule%sA Datamodule for REST Dataware Web Components.';

Var
 PDRESTDWCGIApplication : TRESTDWCGIApplicationDescriptor;
 PDRESTDWCGIDatamodule  : TRESTDWCGIDatamodule;
 PDRESTDWDatamodule     : TRESTDWDatamodule;


Implementation

{$R allrestdwreg.res}


uses uDWConsts, uDWConstsData, uDWPoolerMethod, uDWAbout, uSystemEvents, utemplateproglaz;

Constructor TRESTDWCGIApplicationDescriptor.Create;
Begin
 inherited Create;
 Flags := Flags - [pfMainUnitHasCreateFormStatements];
 Name  := 'REST Dataware - CGI Application';
End;

Constructor TRESTDWCGIDatamodule.Create;
Begin
 Inherited Create;
 Name                    := 'RESTDWCGIWebModule';
 ResourceClass           := Trestdwcgiwebmodule;
 UseCreateFormStatements := True;
End;

Constructor TRESTDWDatamodule.Create;
Var
 LFMFilename : String;
Begin
 Inherited Create;
 Name                    := 'RESTDWDatamodule';
 ResourceClass           := TServerMethodDataModule;
 DeclareClassVariable    := True;
 UseCreateFormStatements := True;
 AddToProject            := True;
 RequiredPackages        := 'pl_RESTDataware'; //=== ct9999 ===============
 If TyphonIDE.ActiveProject <> Nil Then
  Begin
   TyphonIDE.ActiveProject.AddPackageDependency(RequiredPackages);
   TyphonIDE.DoNewEditorFile(PDRESTDWDatamodule, '', '',
                              [nfIsPartOfProject, nfOpenInEditor, nfCreateDefaultSrc]);
  End;
End;

Function TRESTDWCGIApplicationDescriptor.GetLocalizedName : String;
Begin
 Result := rsRESTDWCGIApplicati;
End;

Function TRESTDWDatamodule.GetLocalizedName : String;
Begin
 Result := rsRESTDWDatamodule;
End;

Function TRESTDWCGIDatamodule.GetLocalizedName : String;
Begin
 Result := rsRESTDWCGIDatamodule;
End;

Function TRESTDWDatamodule.GetInterfaceUsesSection : String;
Begin
 Result  := Inherited GetInterfaceUsesSection;
 Result  := Result + ', SysTypes, uDWJSONObject, uDWConsts, uDWConstsData,' + LineEnding;
 Result  := Result + '  uDWDatamodule, uRESTDWServerEvents, uDWJSONTools,' + LineEnding;
 Result  := Result + '  uDWConstsCharset, uRESTDWPoolerDB';   //=== ct9999 ======
End;

Function TRESTDWCGIDatamodule.GetInterfaceUsesSection : String;
Begin
 Result  := 'SysUtils, Classes';
 If GetResourceType = rtLRS Then
  Result :=  Result+ ', LResources, ';
 Result  := Result + ', uRESTDWBase, httpdefs, fpHTTP, fpWeb, dmdwcgiserver, unit2';
End;

Function TRESTDWDatamodule.GetInterfaceSource(Const Filename, SourceName, ResourceName : String) : String;
Const
 LE = LineEnding;
Begin
 Result := 'Type'+ LE
         + ' T'+ResourceName+' = Class(TServerMethodDataModule)' + LE
         + 'Private'+LE
         + LE
         + 'Public'+LE
         + LE
         + 'End;'+LE
         + LE;
 If DeclareClassVariable Then
  Result := Result + 'Var' + LE
                   + '  ' + ResourceName + ': T' + ResourceName + ';' + LE + LE;
End;

Function TRESTDWCGIDatamodule.GetInterfaceSource(Const Filename, SourceName, ResourceName : String) : String;
Const
 LE = LineEnding;
Begin
 Result := 'Type'+ LE
         + '  T'+ResourceName+' = class(Trestdwcgiwebmodule)'+LE
         + '  Private'+LE
         + LE
         + '  Public'+LE
         + LE
         + ' End;'+LE
         + LE;
 If DeclareClassVariable Then
  Result := Result + 'Var' + LE
                   + '  ' + ResourceName + ': T' + ResourceName + ';' + LE + LE;
End;

Function TRESTDWCGIApplicationDescriptor.GetLocalizedDescription : String;
Begin
 Result := Format(rsRESTDWCGIApplicatiDesc, [#13#13]);
End;

Function TRESTDWDatamodule.GetLocalizedDescription : String;
Begin
 Result := Format(rsRESTDWDatamoduleADa, [#13#13]);
End;

Function TRESTDWCGIDatamodule.GetLocalizedDescription : String;
Begin
 Result := Format(rsRESTDWCGIDatamoduleADa, [#13#13]);
End;

Function TRESTDWCGIApplicationDescriptor.InitProject(AProject : TTyphonProject) : TModalResult;
Var
 NewSource : String;
 MainFile  : TTyphonProjectFile;
Begin
 Inherited InitProject(AProject);
 MainFile                 := AProject.CreateProjectFile('restdwcgiproject1.ppr');
 MainFile.IsPartOfProject := True;
 AProject.AddFile(MainFile, false);
 AProject.MainFileID      := 0;
 // create program source
 NewSource                := cRESTDWcgiproject;
 AProject.MainFile.SetSourceText(NewSource);

//=== ct9999 ==============================
 AProject.AddPackageDependency('lz_FpWeb');
//========================================

 // compiler options
 AProject.TyphonCompilerOptions.Win32GraphicApp := False;
 AProject.TyphonCompilerOptions.BuildMacros.Add('LCLWidgetType');
 AProject.TyphonCompilerOptions.BuildMacros.Items[AProject.TyphonCompilerOptions.BuildMacros.IndexOfIdentifier('LCLWidgetType')].Values.Text := 'LCLWidgetType:=nogui';
 AProject.TyphonCompilerOptions.UnitOutputDirectory := 'lib' + PathDelim + '$(TargetCPU)-$(TargetOS)';
 AProject.Flags           := AProject.Flags - [pfMainUnitHasCreateFormStatements];
 Result                   := mrOK;
End;

Function TRESTDWDatamodule.GetImplementationSource(const Filename, SourceName, ResourceName : String) : String;
Begin
 Result := Inherited GetImplementationSource(FileName, SourceName, ResourceName);
End;

Function TRESTDWCGIDatamodule.GetImplementationSource(const Filename, SourceName, ResourceName : String) : String;
Var
 ResourceFilename: String;
Begin
  Result := '';

 Case GetResourceType Of
  rtLRS :
   Begin
    ResourceFilename := TrimFilename(ExtractFilenameOnly(Filename) + DefaultResFileExt);
    Result           := 'Initialization' + LineEnding + '  {$I ' + ResourceFilename + '}' + LineEnding + LineEnding;
   End;
  rtRes :
   begin
    Result := '{$R *.frm}' + LineEnding + LineEnding;
   end;
 End;

 Result := Result + 'Initialization' + LineEnding + ' RegisterHTTPModule('''', T' + ResourceName + ');' + LineEnding;
End;

Function TRESTDWCGIApplicationDescriptor.CreateStartFiles(AProject : TTyphonProject): TModalResult;
Begin
 TyphonIDE.DoNewEditorFile(PDRESTDWCGIDatamodule, '', '',
                            [nfIsPartOfProject, nfOpenInEditor, nfCreateDefaultSrc]);
 TyphonIDE.DoNewEditorFile(PDRESTDWDatamodule, '', '',
                            [nfIsPartOfProject, nfOpenInEditor, nfCreateDefaultSrc]);
 Result:= mrOK;
End;

Function TPoolersListCDF.GetAttributes : TPropertyAttributes;
Begin
  // editor, sorted list, multiple selection
 Result := [paValueList, paSortList];
End;

Function TTableList.GetAttributes : TPropertyAttributes;
Begin
  // editor, sorted list, multiple selection
 Result := [paValueList, paSortList];
End;

Function TPoolersList.GetAttributes : TPropertyAttributes;
Begin
  // editor, sorted list, multiple selection
 Result := [paValueList, paSortList];
End;

procedure TPoolersListCDF.Edit;
Var
 vTempData : String;
Begin
 Inherited Edit;
 Try
  vTempData := GetValue;
  SetValue(vTempData);
 Finally
 End;
end;

procedure TTableList.Edit;
Var
 vTempData : String;
Begin
 Inherited Edit;
 Try
  vTempData := GetValue;
  SetValue(vTempData);
 Finally
 End;
end;

procedure TPoolersList.Edit;
Var
 vTempData : String;
Begin
 Inherited Edit;
 Try
  vTempData := GetValue;
  SetValue(vTempData);
 Finally
 End;
end;

Procedure TPoolersListCDF.GetValues(Proc : TGetStrProc);
Var
 vLista : TStringList;
 I      : Integer;
Begin
 //Provide a list of Poolers
 vLista := Nil;
 If GetComponent(0) is TRESTDWConnectionServer Then
  Begin
   With GetComponent(0) as TRESTDWConnectionServer Do
    Begin
     vLista := TRESTDWConnectionServer(GetComponent(0)).PoolerList;
     Try
      If Assigned(vLista) Then
       For I := 0 To vLista.Count -1 Do
        Proc (vLista[I]);
     Finally
      If Assigned(vLista) Then
       FreeAndNil(vLista);
     End;
    End;
  End
 Else If GetComponent(0) is TRESTDWConnectionParams Then
  Begin
   With GetComponent(0) as TRESTDWConnectionParams Do
    Begin
     vLista := TRESTDWConnectionParams(GetComponent(0)).PoolerList;
     Try
      If Assigned(vLista) Then
       For I := 0 To vLista.Count -1 Do
        Proc (vLista[I]);
     Finally
      If Assigned(vLista) Then
       FreeAndNil(vLista);
     End;
    End;
  End;
End;

Procedure TTableList.GetValues(Proc : TGetStrProc);
Var
 vLista : TStringList;
 I      : Integer;
Begin
 //Provide a list of Tables
 vLista := Nil;
 With GetComponent(0) as TRESTDWTable Do
  Begin
   Try
    If TRESTDWTable(GetComponent(0)).DataBase <> Nil Then
     Begin
      TRESTDWTable(GetComponent(0)).DataBase.GetTableNames(vLista);
      For I := 0 To vLista.Count -1 Do
       Proc (vLista[I]);
     End;
   Except
   End;
  End;
End;

Procedure TPoolersList.GetValues(Proc : TGetStrProc);
Var
 vLista : TStringList;
 I      : Integer;
Begin
 //Provide a list of Poolers
 With GetComponent(0) as TRESTDWDataBase Do
  Begin
   Try
    vLista := TRESTDWDataBase(GetComponent(0)).PoolerList;
    For I := 0 To vLista.Count -1 Do
     Proc (vLista[I]);
   Except
   End;
  End;
End;

{Ico Testando }
{Editor de Proriedades de Componente para mostrar o AboutDW}
Type
 TDWAboutDialogProperty = class(TClassPropertyEditor)
Public
 Procedure Edit; override;
 Function  GetAttributes : TPropertyAttributes; Override;
 Function  GetValue      : String;              Override;
End;

Procedure TDWAboutDialogProperty.Edit;
Begin
 DWAboutDialog;
End;

Function TDWAboutDialogProperty.GetAttributes: TPropertyAttributes;
Begin
 Result := [paDialog, paReadOnly];
End;

Function TDWAboutDialogProperty.GetValue: String;
Begin
 Result := 'Version : '+ DWVERSAO;
End;

procedure TDWServerContextEditor.ExecuteVerb(Index: Integer);
Begin
 Case Index of
  0 :
       TCollectionPropertyEditor.ShowCollectionEditor(TDWServerContext(Component).ContextList, Component, 'ContextList');

 End;
end;

procedure TDWContextRulesEditor.ExecuteVerb(Index: Integer);
Begin
 Case Index of
  0 :
       TCollectionPropertyEditor.ShowCollectionEditor(TDWContextRules(Component).Items, Component, 'Items');

 End;
end;

Function TDWServerContextEditor.GetVerb(Index: Integer): string;
Begin
 Case Index of
  0 : Result := '&ContextList Editor';
 End;
End;

Function TDWContextRulesEditor.GetVerb(Index: Integer): string;
Begin
 Case Index of
  0 : Result := '&ContextRules Editor';
 End;
End;

Function TDWServerContextEditor.GetVerbCount: Integer;
Begin
 Result := 1;
End;

Function TDWContextRulesEditor.GetVerbCount: Integer;
Begin
 Result := 1;
End;

Procedure Register;
Begin

  FormEditingHook.RegisterDesignerBaseClass(TServerMethodDataModule);
  PDRESTDWCGIApplication    := TRESTDWCGIApplicationDescriptor.Create;
  RegisterProjectDescriptor (PDRESTDWCGIApplication);
  PDRESTDWCGIDatamodule     := TRESTDWCGIDatamodule.Create;
  PDRESTDWDatamodule        := TRESTDWDatamodule.Create;
  RegisterProjectFileDescriptor(PDRESTDWDatamodule);
  FormEditingHook.RegisterDesignerBaseClass(TServerMethodDataModule);
//  RegisterProjectFileDescriptor(PDRESTDWCGIDatamodule);

 RegisterComponents('RESTDataware-Service',  [TRESTServicePooler,
                                               TRESTServiceCGI,
                                               TDWServerEvents,
                                               TRESTDWServiceNotification]);
                                                  
 RegisterComponents('RESTDataware-Clients',   [TDWClientREST,
                                               TDWClientEvents,
                                               TRESTClientPooler,
                                               TRESTDWClientNotification]);
                                                
 RegisterComponents('RESTDataware-Webpascal', [TDWServerContext,
                                               TDWContextRules]);

 RegisterComponents('RESTDataware-Tools',     [TDWResponseTranslator,
                                               TRESTDWBufferDB]);

 RegisterComponents('RESTDataware-DB',        [TRESTDWPoolerDB,   
                                                TRESTDWDataBase,    
                                                TRESTDWClientSQL,  
                                                TRESTDWTable,      
                                                TRESTDWUpdateSQL,
                                                TDWMemtable,        
                                                TDWMassiveSQLCache, 
                                                TRESTDWStoredProc, 
                                                TRESTDWPoolerList, 
                                                TDWMassiveCache,  
                                                TRESTDWBatchMove]);

 RegisterComponents('RESTDataware-Drivers',     [TRESTDWLazDriver,
                                                 TRESTDWDriverZEOS,
                                                 TRESTDWDriverRDW]);

 AddIDEMenu; 
 

 RegisterPropertyEditor(TypeInfo(String),       TRESTDWDataBase,           'PoolerName',      TPoolersList);
 RegisterPropertyEditor(TypeInfo(String),       TRESTDWTable,              'Tablename',       TTableList);
 RegisterPropertyEditor(TypeInfo(String),       TRESTDWConnectionServer,   'PoolerName',      TPoolersListCDF);
 RegisterPropertyEditor(TypeInfo(String),       TRESTDWConnectionParams,   'PoolerName',      TPoolersListCDF);
 RegisterPropertyEditor(TypeInfo(String),       TDWClientEvents,           'ServerEventName', TServerEventsList);
 RegisterPropertyEditor(TypeInfo(String),       TRESTDWConnectionServerCP, 'ServerEventName', TServerEventsListCV);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWClientSQL,          'SQL',             TDWSQLEditor);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWClientSQL,          'RelationFields',  TDWFieldsRelationEditor);
 RegisterPropertyEditor(TypeInfo(String),       TRESTDWClientSQL,          'SequenceField',   TDWFieldsList);

 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWUpdateSQL,          'DeleteSQL',       TDWUpdSQLEditorDelete);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWUpdateSQL,          'InsertSQL',       TDWUpdSQLEditorInsert);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWUpdateSQL,          'LockSQL',         TDWUpdSQLEditorLock);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWUpdateSQL,          'UnlockSQL',       TDWUpdSQLEditorUnlock);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWUpdateSQL,          'FetchRowSQL',     TDWUpdSQLEditorFetchRow);
 RegisterPropertyEditor(TypeInfo(TStrings),     TRESTDWUpdateSQL,          'ModifySQL',       TDWUpdSQLEditorModify);
 RegisterComponentEditor(TRESTDWUpdateSQL,      TDWUpdateSQLEditor);

 RegisterComponentEditor(TDWServerEvents,       TDWServerEventsEditor);
 RegisterComponentEditor(TDWClientEvents,       TDWClientEventsEditor);
 RegisterComponentEditor(TDWResponseTranslator, TDWJSONViewer);
 RegisterComponentEditor(TDWServerContext,      TDWServerContextEditor);
 RegisterComponentEditor(TDWContextRules,       TDWContextRulesEditor);

End;

{ TDWServerEventsEditor }

procedure TDWServerEventsEditor.ExecuteVerb(Index: Integer);
begin
 Inherited;
 Case Index of
  0 : Begin
        TCollectionPropertyEditor.ShowCollectionEditor(TDWServerEvents(Component).Events, Component, 'Events');
      End;
 End;
End;

Function TDWServerEventsEditor.GetVerb(Index: Integer): String;
Begin
 Case Index of
  0 : Result := 'Events &List';
 End;
End;

function TDWServerEventsEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

Procedure TDWClientEventsEditor.ExecuteVerb(Index: Integer);
Begin
 Inherited;
 Case Index of
  // Procedure in the unit ColnEdit.pas
   0 : Begin
         TCollectionPropertyEditor.ShowCollectionEditor(TDWClientEvents(Component).Events,Component, 'Events');
       End;
   1 : (Component as TDWClientEvents).GetEvents := True;
   2 : (Component as TDWClientEvents).ClearEvents;
 End;
End;

Function TDWClientEventsEditor.GetVerb(Index: Integer): string;
Begin
 Case Index of
  0 : Result := 'Events &List';
  1 : Result := '&Get Server Events';
  2 : Result := '&Clear Client Events';
 End;
End;

Function TDWClientEventsEditor.GetVerbCount: Integer;
Begin
 Result := 3;
End;

{ TServerEventsList }

procedure TServerEventsListCV.Edit;
Var
 vTempData : String;
Begin
 Inherited Edit;
 Try
  vTempData := GetValue;
  SetValue(vTempData);
 Finally
 End;
End;

procedure TServerEventsList.Edit;
Var
 vTempData : String;
Begin
 Inherited Edit;
 Try
  vTempData := GetValue;
  SetValue(vTempData);
 Finally
 End;
End;


Function TServerEventsListCV.GetAttributes: TPropertyAttributes;
begin
  // editor, sorted list, multiple selection
 Result := [paValueList, paSortList];
end;

Function TServerEventsList.GetAttributes: TPropertyAttributes;
begin
  // editor, sorted list, multiple selection
 Result := [paValueList, paSortList];
end;

procedure TServerEventsListCV.GetValues(Proc: TGetStrProc);
Var
 vLista : TStringList;
 I      : Integer;
Begin
 //Provide a list of Poolers
 vLista := Nil;
 With GetComponent(0) as TRESTDWConnectionServerCP Do
  Begin
   vLista := TRESTDWConnectionServerCP(GetComponent(0)).GetPoolerList;
   Try
    For I := 0 To vLista.Count -1 Do
     Proc (vLista[I]);
   Except
   End;
   FreeAndNil(vLista);
  End;
End;

procedure TServerEventsList.GetValues(Proc: TGetStrProc);
Var
 vLista : TStringList;
 I      : Integer;
 Function GetRestPoolers : TStringList;
 Var
  vTempList     : TStringList;
  vConnection   : TDWPoolerMethodClient;
  I             : Integer;
  vRESTClientPooler : TRESTClientPooler;
 Begin
  Result := Nil;
  If TDWClientEvents(GetComponent(0)).RESTClientPooler <> Nil Then
   Begin
    vRESTClientPooler                     := TDWClientEvents(GetComponent(0)).RESTClientPooler;
    vConnection                           := TDWPoolerMethodClient.Create(Nil);
    vConnection.WelcomeMessage            := vRESTClientPooler.WelcomeMessage;
    vConnection.Host                      := vRESTClientPooler.Host;
    vConnection.Port                      := vRESTClientPooler.Port;
    vConnection.Compression               := vRESTClientPooler.DataCompression;
    vConnection.TypeRequest               := vRESTClientPooler.TypeRequest;
    vConnection.AccessTag                 := vRESTClientPooler.AccessTag;
    vConnection.CriptOptions.Use          := vRESTClientPooler.CriptOptions.Use;
    vConnection.CriptOptions.Key          := vRESTClientPooler.CriptOptions.Key;
    vConnection.DataRoute                 := vRESTClientPooler.DataRoute;
    vConnection.ServerContext             := vRESTClientPooler.ServerContext;
    vConnection.AuthenticationOptions.Assign(vRESTClientPooler.AuthenticationOptions);
    Result := TStringList.Create;
    Try
     vTempList := vConnection.GetServerEvents(vRESTClientPooler.UrlPath,
                                              vRESTClientPooler.RequestTimeOut);
     Try
      For I := 0 To vTempList.Count -1 do
       Result.Add(vTempList[I]);
     Finally
      If Assigned(vTempList) Then
       vTempList.Free;
     End;
    Except
     On E : Exception do
      Begin
       Raise Exception.Create(E.Message);
      End;
    End;
    FreeAndNil(vConnection);
   End;
 End;
Begin
 //Provide a list of Poolers
 vLista := Nil;
 With GetComponent(0) as TDWClientEvents Do
  Begin
   vLista := GetRestPoolers;
   Try
    For I := 0 To vLista.Count -1 Do
     Proc (vLista[I]);
   Except
   End;
   FreeAndNil(vLista);
  End;
End;

{ TDWFieldsList }

procedure TDWFieldsList.Edit;
Var
 vTempData : String;
Begin
 Inherited Edit;
 Try
  vTempData := GetValue;
  SetValue(vTempData);
 Finally
 End;
End;

Function TDWFieldsList.GetAttributes : TPropertyAttributes;
Begin
  // editor, sorted list, multiple selection
 Result := [paValueList, paSortList];
End;

procedure TDWFieldsList.GetValues(Proc: TGetStrProc);
Var
 I      : Integer;
Begin
 //Provide a list of Poolers
 With GetComponent(0) as TRESTDWClientSQL Do
  Begin
   Try
    If TRESTDWClientSQL(GetComponent(0)).Fields.Count > 0 Then
     Begin
      For I := 0 To TRESTDWClientSQL(GetComponent(0)).Fields.Count -1 Do
       Proc (TRESTDWClientSQL(GetComponent(0)).Fields[I].FieldName);
     End
    Else
     Begin
      For I := 0 To TRESTDWClientSQL(GetComponent(0)).FieldDefs.Count -1 Do
       Proc (TRESTDWClientSQL(GetComponent(0)).FieldDefs[I].Name);
     End;
   Except
   End;
  End;
End;

 Procedure UnlistPublishedProperty (ComponentClass:TPersistentClass; const PropertyName:String);
 var
   pi :PPropInfo;
 begin
   pi := TypInfo.GetPropInfo (ComponentClass, PropertyName);
   if (pi <> nil) then
     RegisterPropertyEditor (pi^.PropType, ComponentClass, PropertyName, PropEdits.THiddenPropertyEditor);
 end;

initialization

 UnlistPublishedProperty(TRESTDWClientSQL,  'FieldDefs');
 UnlistPublishedProperty(TRESTDWClientSQL,  'Options');
 UnlistPublishedProperty(TRESTDWStoredProc, 'SequenceName');
 UnlistPublishedProperty(TRESTDWStoredProc, 'SequenceField');
 UnlistPublishedProperty(TRESTDWStoredProc, 'OnWriterProcess');
 UnlistPublishedProperty(TRESTDWStoredProc, 'FieldDefs');
 UnlistPublishedProperty(TRESTDWStoredProc, 'Options');

end.
